Index: CKEditor/branches/features/paste/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/branches/features/paste/_source/plugins/wysiwygarea/plugin.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/plugins/wysiwygarea/plugin.js	(revision 4743)
@@ -15,5 +15,5 @@
 
 	// Matching an empty paragraph at the end of document.
-	var emptyParagraphRegexp = /\s*<(p|div|address|h\d|center)[^>]*>\s*(?:<br[^>]*>|&nbsp;|\u00A0|&#160;)\s*(:?<\/\1>)?\s*(?=$|<\/body>)/gi;
+	var emptyParagraphRegexp = /\s*<(p|div|address|h\d|center)[^>]*>\s*(?:<br[^>]*>|&nbsp;|\u00A0|&#160;)?\s*(:?<\/\1>)?\s*(?=$|<\/body>)/gi;
 
 	function onInsertHtml( evt )
@@ -93,7 +93,10 @@
 							&& !( dtd && dtd [ elementName ] ) )
 					{
+						// Split up inline elements.
+						if ( current.getName() in CKEDITOR.dtd.span )
+							range.splitElement( current );
 						// If we're in an empty block which indicate a new paragraph,
 						// simply replace it with the inserting block.(#3664)
-						if ( range.checkStartOfBlock()
+						else if ( range.checkStartOfBlock()
 							 && range.checkEndOfBlock() )
 						{
@@ -150,5 +153,5 @@
 	{
 		return isNotWhitespace( node ) && isNotBookmark( node );
-	};
+	}
 
 	function isNbsp( node )
@@ -180,6 +183,5 @@
 		{
 			restoreDirty( editor );
-			var bms = selection.createBookmarks(),
-				fixedBlock = range.fixBlock( true,
+			var fixedBlock = range.fixBlock( true,
 					editor.config.enterMode == CKEDITOR.ENTER_DIV ? 'div' : 'p'  );
 
@@ -191,35 +193,32 @@
 			}
 
-			selection.selectBookmarks( bms );
-
-			// If the fixed block is blank and is already followed by a exitable
-			// block, we should drop it and move to the exist block(#3684).
-			var children = fixedBlock.getChildren(),
-				count = children.count(),
-				firstChild,
-				previousElement = fixedBlock.getPrevious( isNotWhitespace ),
-				nextElement = fixedBlock.getNext( isNotWhitespace ),
-				enterBlock;
-			if ( previousElement && previousElement.getName
-				 && !( previousElement.getName() in nonExitableElementNames ) )
-				enterBlock = previousElement;
-			else if ( nextElement && nextElement.getName
-					  && !( nextElement.getName() in nonExitableElementNames ) )
-				enterBlock = nextElement;
-
-			// Not all blocks are editable, e.g. <hr />, further checking it.(#3994)
-			if( ( !count
-				  || ( firstChild = children.getItem( 0 ) ) && firstChild.is && firstChild.is( 'br' ) )
-				&& enterBlock
-				&& range.moveToElementEditStart( enterBlock ) )
+			// If the fixed block is blank and already followed by a exitable
+			// block, we should revert the fix. (#3684)
+			if( fixedBlock.getOuterHtml().match( emptyParagraphRegexp ) )
 			{
-				fixedBlock.remove();
-				range.select();
+				var previousElement = fixedBlock.getPrevious( isNotWhitespace ),
+					nextElement = fixedBlock.getNext( isNotWhitespace );
+
+
+				if ( previousElement && previousElement.getName
+					 && !( previousElement.getName() in nonExitableElementNames )
+					 && range.moveToElementEditStart( previousElement )
+					 || nextElement && nextElement.getName
+					   && !( nextElement.getName() in nonExitableElementNames )
+					   && range.moveToElementEditStart( nextElement ) )
+				{
+					fixedBlock.remove();
+				}
 			}
+
+			range.select();
+			// Notify non-IE that selection has changed.
+			if( !CKEDITOR.env.ie )
+				editor.selectionChange();
 		}
 
 		// All browsers are incapable to moving cursor out of certain non-exitable
 		// blocks (e.g. table, list, pre) at the end of document, make this happen by
-		// place a bogus node there, which would be later removed by dataprocessor.  
+		// place a bogus node there, which would be later removed by dataprocessor.
 		var lastNode = body.getLast( CKEDITOR.dom.walker.whitespaces( true ) );
 		if ( lastNode && lastNode.getName && ( lastNode.getName() in nonExitableElementNames ) )
@@ -425,5 +424,5 @@
 								// Setting focus directly on editor doesn't work, we
 								// have to use here a temporary element to 'redirect'
-								// the focus. 
+								// the focus.
 								if ( evt.data.getTarget().equals( htmlElement ) )
 									ieFocusGrabber.focus();
Index: CKEditor/branches/features/paste/_source/skins/kama/skin.js
===================================================================
--- CKEditor/branches/features/paste/_source/skins/kama/skin.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/skins/kama/skin.js	(revision 4743)
@@ -212,6 +212,5 @@
 				height = data.height,
 				dialog = data.dialog,
-				contents = dialog.parts.contents,
-				standardsMode = !CKEDITOR.env.quirks;
+				contents = dialog.parts.contents;
 
 			if ( data.skin != 'kama' )
@@ -219,26 +218,14 @@
 
 			contents.setStyles(
-				( CKEDITOR.env.ie || ( CKEDITOR.env.gecko && CKEDITOR.env.version < 10900 ) ) ?		// IE && FF2
-					{
-						width : width + 'px',
-						height : height + 'px'
-					}
-				:
-					{
-						// To avoid having scrollbars in the dialogs, we're
-						// (for now) using the "min-xxx" properties, for
-						// browsers which well support it (#3878).
-						'min-width' : width + 'px',
-						'min-height' : height + 'px'
-					});
-
-			if ( !CKEDITOR.env.ie )
-				return;
+				{
+					width : width + 'px',
+					height : height + 'px'
+				});
 
 			// Fix the size of the elements which have flexible lengths.
 			setTimeout( function()
 				{
-					var body = contents.getParent(),
-						innerDialog = body.getParent();
+					var innerDialog = dialog.parts.dialog.getChild( [ 0, 0, 0 ] ),
+						body = innerDialog.getChild( 0 );
 
 					// tc
Index: CKEditor/branches/features/paste/_source/skins/office2003/skin.js
===================================================================
--- CKEditor/branches/features/paste/_source/skins/office2003/skin.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/skins/office2003/skin.js	(revision 4743)
@@ -32,10 +32,10 @@
 				height = data.height,
 				dialog = data.dialog,
-				standardsMode = !CKEDITOR.env.quirk;
+				contents = dialog.parts.contents;
 
 			if ( data.skin != 'office2003' )
 				return;
 
-			dialog.parts.contents.setStyles(
+			contents.setStyles(
 				{
 					width : width + 'px',
@@ -49,7 +49,6 @@
 			var fixSize = function()
 				{
-					var content = dialog.parts.contents,
-						body = content.getParent(),
-						innerDialog = body.getParent();
+					var innerDialog = dialog.parts.dialog.getChild( [ 0, 0, 0 ] ),
+						body = innerDialog.getChild( 0 );
 
 					// tc
Index: CKEditor/branches/features/paste/_source/skins/v2/skin.js
===================================================================
--- CKEditor/branches/features/paste/_source/skins/v2/skin.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/skins/v2/skin.js	(revision 4743)
@@ -32,10 +32,10 @@
 				height = data.height,
 				dialog = data.dialog,
-				standardsMode = !CKEDITOR.env.quirk;
+				contents = dialog.parts.contents;
 
 			if ( data.skin != 'v2' )
 				return;
 
-			dialog.parts.contents.setStyles(
+			contents.setStyles(
 				{
 					width : width + 'px',
@@ -49,7 +49,6 @@
 			setTimeout( function()
 				{
-					var content = dialog.parts.contents,
-						body = content.getParent(),
-						innerDialog = body.getParent();
+					var innerDialog = dialog.parts.dialog.getChild( [ 0, 0, 0 ] ),
+						body = innerDialog.getChild( 0 );
 
 					// tc
Index: CKEditor/branches/features/paste/_source/themes/default/theme.js
===================================================================
--- CKEditor/branches/features/paste/_source/themes/default/theme.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/themes/default/theme.js	(revision 4743)
@@ -169,7 +169,7 @@
 						' lang="', editor.langCode, '"' +
 						'>' +
-
-						'<div class="cke_dialog', ' ' + CKEDITOR.env.cssClass,
+						'<table class="cke_dialog', ' ' + CKEDITOR.env.cssClass,
 							' cke_', editor.lang.dir, '" style="position:absolute">' +
+							'<tr><td>' +
 							'<div class="%body">' +
 								'<div id="%title#" class="%title"></div>' +
@@ -178,5 +178,7 @@
 								'</div>' +
 								'<div id="%tabs#" class="%tabs"></div>' +
-								'<div id="%contents#" class="%contents"></div>' +
+								  '<table class="%contents"><tr>' +
+								  '<td id="%contents#" class="%contents"></td>' +
+								  '</tr></table>' +
 								'<div id="%footer#" class="%footer"></div>' +
 							'</div>' +
@@ -189,5 +191,6 @@
 							'<div id="%bc#" class="%bc"></div>' +
 							'<div id="%br#" class="%br"></div>' +
-						'</div>',
+							'</td></tr>' +
+						'</table>',
 
 						//Hide the container when loading skins, later restored by skin css.
@@ -199,9 +202,11 @@
 					.replace( /%/g, 'cke_dialog_' ) );
 
-			var body = element.getChild( [ 0, 0 ] );
+			var body = element.getChild( [ 0, 0, 0, 0, 0 ] ),
+				title = body.getChild( 0 ),
+				close = body.getChild( 1 );
 
 			// Make the Title and Close Button unselectable.
-			body.getChild( 0 ).unselectable();
-			body.getChild( 1 ).unselectable();
+			title.unselectable();
+			close.unselectable();
 
 
@@ -211,8 +216,8 @@
 				{
 					dialog		: element.getChild( 0 ),
-					title		: body.getChild( 0 ),
-					close		: body.getChild( 1 ),
+					title		: title,
+					close		: close,
 					tabs		: body.getChild( 2 ),
-					contents	: body.getChild( 3 ),
+					contents	: body.getChild( [ 3, 0, 0, 0 ] ),
 					footer		: body.getChild( 4 )
 				}
Index: CKEditor/branches/features/paste/ckeditor.php
===================================================================
--- CKEditor/branches/features/paste/ckeditor.php	(revision 4743)
+++ CKEditor/branches/features/paste/ckeditor.php	(revision 4743)
@@ -0,0 +1,29 @@
+<?php
+/*
+ * Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+ * For licensing, see LICENSE.html or http://ckeditor.com/license
+ */
+
+/*! \mainpage CKEditor - PHP server side intergation
+ * \section intro_sec CKEditor
+ * Visit <a href="http://ckeditor.com">CKEditor web site</a> to find more information about the editor.
+ * \section install_sec Installation
+ * \subsection step1 Include ckeditor.php in your PHP web site.
+ * @code
+ * <?php
+ * include("ckeditor/ckeditor.php");
+ * ?>
+ * @endcode
+ * \subsection step2 Create CKEditor class instance and use one of available methods to insert CKEditor.
+ * @code
+ * <?php
+ * $CKEditor = new CKEditor();
+ * echo $CKEditor->textarea("field1", "<p>Initial value.</p>");
+ * ?>
+ * @endcode
+ */
+
+if ( !function_exists('version_compare') || version_compare( phpversion(), '5', '<' ) )
+	include_once( 'ckeditor_php4.php' ) ;
+else
+	include_once( 'ckeditor_php5.php' ) ;
Index: CKEditor/branches/features/paste/ckeditor_php4.php
===================================================================
--- CKEditor/branches/features/paste/ckeditor_php4.php	(revision 4743)
+++ CKEditor/branches/features/paste/ckeditor_php4.php	(revision 4743)
@@ -0,0 +1,598 @@
+<?php
+/*
+* Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+* For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+/**
+ * \brief CKEditor class that can be used to create editor
+ * instances in PHP pages on server side.
+ * @see http://ckeditor.com
+ *
+ * Sample usage:
+ * @code
+ * $CKEditor = new CKEditor();
+ * $CKEditor->editor("editor1", "<p>Initial value.</p>");
+ * @endcode
+ */
+class CKEditor
+{
+	/**
+	 * The version of %CKEditor.
+	 * \private
+	 */
+	var $version = '%VERSION%';
+	/**
+	 * A constant string unique for each release of %CKEditor.
+	 * \private
+	 */
+	var $_timestamp = '%TIMESTAMP%';
+
+	/**
+	 * URL to the %CKEditor installation directory (absolute or relative to document root).
+	 * If not set, CKEditor will try to guess it's path.
+	 *
+	 * Example usage:
+	 * @code
+	 * $CKEditor->basePath = '/ckeditor/';
+	 * @endcode
+	 */
+	var $basePath;
+	/**
+	 * An array that holds the global %CKEditor configuration.
+	 * For the list of available options, see http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.config.html
+	 *
+	 * Example usage:
+	 * @code
+	 * $CKEditor->config['height'] = 400;
+	 * // Use @@ at the beggining of a string to ouput it without surrounding quotes.
+	 * $CKEditor->config['width'] = '@@screen.width * 0.8';
+	 * @endcode
+	 */
+	var $config = array();
+	/**
+	 * A boolean variable indicating whether CKEditor has been initialized.
+	 * Set it to true only if you have already included
+	 * &lt;script&gt; tag loading ckeditor.js in your website. 
+	 */
+	var $initialized = false;
+	/**
+	 * Boolean variable indicating whether created code should be printed out or returned by a function.
+	 *
+	 * Example 1: get the code creating %CKEditor instance and print it on a page with the "echo" function. 
+	 * @code
+	 * $CKEditor = new CKEditor();
+	 * $CKEditor->returnOutput = true;
+	 * $code = $CKEditor->editor("editor1", "<p>Initial value.</p>");
+	 * echo "<p>Editor 1:</p>";
+	 * echo $code;
+	 * @endcode
+	 */
+	var $returnOutput = false;
+	/**
+	 * An array with textarea attributes.
+	 *
+	 * When %CKEditor is created with the editor() method, a HTML &lt;textarea&gt; element is created,
+	 * it will be displayed to anyone with JavaScript disabled or with incompatible browser.
+	 */	
+	var $textareaAttributes = array( "rows" => 8, "cols" => 60 );
+	/**
+	 * A string indicating the creation date of %CKEditor.
+	 * Do not change it unless you want to force browsers to not use previously cached version of %CKEditor.
+	 */
+	var $timestamp = "%TIMESTAMP%";
+	/**
+	 * An array that holds event listeners.
+	 * \private
+	 */
+	var $_events = array();
+	/**
+	 * An array that holds global event listeners.
+	 * \private
+	 */
+	var $_globalEvents = array();
+
+	/**
+	 * Main Constructor.
+	 *
+	 *  @param $basePath (string) URL to the %CKEditor installation directory (optional).
+	 */
+	function CKEditor($basePath = null) {
+		if (!empty($basePath)) {
+			$this->basePath = $basePath;
+		}
+	}
+
+	/**
+	 * Creates a %CKEditor instance. 
+	 * In incompatible browsers %CKEditor will downgrade to plain HTML &lt;textarea&gt; element.
+	 *
+	 * @param $name (string) Name of the %CKEditor instance (this will be also the "name" attribute of textarea element).
+	 * @param $value (string) Initial value (optional).
+	 * @param $config (array) The specific configurations to apply to this editor instance (optional).
+	 * @param $events (array) Event listeners for this editor instance (optional).
+	 *
+	 * Example usage:
+	 * @code
+	 * $CKEditor = new CKEditor();
+	 * $CKEditor->editor("field1", "<p>Initial value.</p>");
+	 * @endcode
+	 *
+	 * Advanced example:
+	 * @code
+	 * $CKEditor = new CKEditor();
+	 * $config = array();
+	 * $config['toolbar'] = array(
+	 *     array( 'Source', '-', 'Bold', 'Italic', 'Underline', 'Strike' ),
+	 *     array( 'Image', 'Link', 'Unlink', 'Anchor' )
+	 * );
+	 * $events['instanceReady'] = 'function (ev) {
+	 *     alert("Loaded: " + ev.editor.name);
+	 * }';
+	 * $CKEditor->editor("field1", "<p>Initial value.</p>", $config, $events);
+	 * @endcode
+	 */
+	function editor($name, $value = "", $config = array(), $events = array())
+	{
+		$attr = "";
+		foreach ($this->textareaAttributes as $key => $val) {
+			$attr.= " " . $key . '="' . str_replace('"', '&quot;', $val) . '"';
+		}
+		$out = "<textarea name=\"" . $name . "\"" . $attr . ">" . htmlspecialchars($value) . "</textarea>\n";
+		if (!$this->initialized) {
+			$out .= $this->init();
+		}
+
+		$_config = $this->configSettings($config, $events);
+
+		$js = $this->returnGlobalEvents();
+		if (!empty($_config))
+			$js .= "CKEDITOR.replace('".$name."', ".$this->jsEncode($_config).");";
+		else
+			$js .= "CKEDITOR.replace('".$name."');";
+
+		$out .= $this->script($js);
+
+		if (!$this->returnOutput) {
+			print $out;
+			$out = "";
+		}
+
+		return $out;
+	}
+
+	/**
+	 * Replaces a &lt;textarea&gt; with a %CKEditor instance.
+	 *
+	 * @param $id (string) The id or name of textarea element.
+	 * @param $config (array) The specific configurations to apply to this editor instance (optional).
+	 * @param $events (array) Event listeners for this editor instance (optional).
+	 *
+	 * Example 1: adding %CKEditor to &lt;textarea name="article"&gt;&lt;/textarea&gt; element:
+	 * @code
+	 * $CKEditor = new CKEditor();
+	 * $CKEditor->replace("article");
+	 * @endcode
+	 */
+	function replace($id, $config = array(), $events = array())
+	{
+		$out = "";
+		if (!$this->initialized) {
+			$out .= $this->init();
+		}
+
+		$_config = $this->configSettings($config, $events);
+
+		$js = $this->returnGlobalEvents();
+		if (!empty($_config)) {
+			$js .= "CKEDITOR.replace('".$id."', ".$this->jsEncode($_config).");";
+		}
+		else {
+			$js .= "CKEDITOR.replace('".$id."');";
+		}
+		$out .= $this->script($js);
+
+		if (!$this->returnOutput) {
+			print $out;
+			$out = "";
+		}
+
+		return $out;
+	}
+
+	/**
+	 * Replace all &lt;textarea&gt; elements available in the document with editor instances.
+	 * 
+	 * @param $className (string) If set, replace all textareas with class className in the page.
+	 *
+	 * Example 1: replace all &lt;textarea&gt; elements in the page.
+	 * @code
+	 * $CKEditor = new CKEditor();
+	 * $CKEditor->replaceAll();
+	 * @endcode
+	 * 
+	 * Example 2: replace all &lt;textarea class="myClassName"&gt; elements in the page.
+	 * @code
+	 * $CKEditor = new CKEditor();
+	 * $CKEditor->replaceAll( 'myClassName' );
+	 * @endcode
+	 */
+	function replaceAll($className = null)
+	{
+		$out = "";
+		if (!$this->initialized) {
+			$out .= $this->init();
+		}
+
+		$_config = $this->configSettings();
+
+		$js = $this->returnGlobalEvents();
+		if (empty($_config)) {
+			if (empty($className)) {
+				$js .= "CKEDITOR.replaceAll();";
+			}
+			else {
+				$js .= "CKEDITOR.replaceAll('".$className."');";
+			}
+		}
+		else {
+			$classDetection = "";
+			$js .= "CKEDITOR.replaceAll( function(textarea, config) {\n";
+			if (!empty($className)) {
+				$js .= "	var classRegex = new RegExp('(?:^| )' + '". $className ."' + '(?:$| )');\n";
+				$js .= "	if (!classRegex.test(textarea.className))\n";
+				$js .= "		return false;\n";
+			}
+			$js .= "	CKEDITOR.tools.extend(config, ". $this->jsEncode($_config) .", true);";
+			$js .= "} );";
+			
+		}
+
+		$out .= $this->script($js);
+
+		if (!$this->returnOutput) {
+			print $out;
+			$out = "";
+		}
+
+		return $out;
+	}
+
+	/**
+	 * Adds event listener.
+	 * Events are fired by %CKEditor in various situations.
+	 *
+	 * @param $event (string) Event name.
+	 * @param $javascriptCode (string) Javascript anonymous function or function name.
+	 *
+	 * Example usage:
+	 * @code
+	 * $CKEditor->addEventHandler('instanceReady', 'function (ev) {
+	 *     alert("Loaded: " + ev.editor.name);
+	 * }');
+	 * @endcode
+	 */
+	function addEventHandler($event, $javascriptCode)
+	{
+		if (!isset($this->_events[$event])) {
+			$this->_events[$event] = array();
+		}
+		// Avoid duplicates.
+		if (!in_array($javascriptCode, $this->_events[$event])) {
+			$this->_events[$event][] = $javascriptCode;
+		}
+	}
+
+	/**
+	 * Clear registered event handlers.
+	 * Note: this function will have no effect on already created editor instances.
+	 * 
+	 * @param $event (string) Event name, if not set all event handlers will be removed (optional).
+	 */
+	function clearEventHandlers($event = null)
+	{
+		if (!empty($event)) {
+			$this->_events[$event] = array();
+		}
+		else {
+			$this->_events = array();
+		}
+	}
+
+	/**
+	 * Adds global event listener.
+	 *
+	 * @param $event (string) Event name.
+	 * @param $javascriptCode (string) Javascript anonymous function or function name.
+	 *
+	 * Example usage:
+	 * @code
+	 * $CKEditor->addGlobalEventHandler('dialogDefinition', 'function (ev) {
+	 *     alert("Loading dialog: " + ev.data.name);
+	 * }');
+	 * @endcode
+	 */
+	function addGlobalEventHandler($event, $javascriptCode)
+	{
+		if (!isset($this->_globalEvents[$event])) {
+			$this->_globalEvents[$event] = array();
+		}
+		// Avoid duplicates.
+		if (!in_array($javascriptCode, $this->_globalEvents[$event])) {
+			$this->_globalEvents[$event][] = $javascriptCode;
+		}
+	}
+
+	/**
+	 * Clear registered global event handlers.
+	 * Note: this function will have no effect if the event handler has been already printed/returned.
+	 *
+	 * @param $event (string) Event name, if not set all event handlers will be removed (optional).
+	 */
+	function clearGlobalEventHandlers($event = null)
+	{
+		if (!empty($event)) {
+			$this->_globalEvents[$event] = array();
+		}
+		else {
+			$this->_globalEvents = array();
+		}
+	}
+
+	/**
+	 * Prints javascript code.
+	 * \private
+	 *
+	 * @param string $js
+	 */
+	function script($js)
+	{
+		$out = "<script type=\"text/javascript\">";
+		$out .= "//<![CDATA[\n";
+		$out .= $js;
+		$out .= "\n//]]>";
+		$out .= "</script>\n";
+
+		return $out;
+	}
+
+	/**
+	 * Returns the configuration array (global and instance specific settings are merged into one array).
+	 * \private
+	 * 
+	 * @param $config (array) The specific configurations to apply to editor instance.
+	 * @param $events (array) Event listeners for editor instance.
+	 */
+	function configSettings($config = array(), $events = array())
+	{
+		$_config = $this->config;
+		$_events = $this->_events;
+
+		if (is_array($config) && !empty($config)) {
+			$_config = array_merge($_config, $config);
+		}
+
+		if (is_array($events) && !empty($events)) {
+			foreach ($events as $eventName => $code) {
+				if (!isset($_events[$eventName])) {
+					$_events[$eventName] = array();
+				}
+				if (!in_array($code, $_events[$eventName])) {
+					$_events[$eventName][] = $code;
+				}
+			}
+		}
+
+		if (!empty($_events)) {
+			foreach($_events as $eventName => $handlers) {
+				if (empty($handlers)) {
+					continue;
+				}
+				else if (count($handlers) == 1) {
+					$_config['on'][$eventName] = '@@'.$handlers[0];
+				}
+				else {
+					$_config['on'][$eventName] = '@@function (ev){';
+					foreach ($handlers as $handler => $code) {
+						$_config['on'][$eventName] .= '('.$code.')(ev);';
+					}
+					$_config['on'][$eventName] .= '}';
+				}
+			}
+		}
+
+		return $_config;
+	}
+
+	/**
+	 * Return global event handlers.
+	 * \private
+	 */
+	function returnGlobalEvents()
+	{
+		static $returnedEvents;
+		$out = "";
+
+		if (!isset($returnedEvents)) {
+			$returnedEvents = array();
+		}
+
+		if (!empty($this->_globalEvents)) {
+			foreach ($this->_globalEvents as $eventName => $handlers) {
+				foreach ($handlers as $handler => $code) {
+					if (!isset($returnedEvents[$eventName])) {
+						$returnedEvents[$eventName] = array();
+					}
+					// Return only new events
+					if (!in_array($code, $returnedEvents[$eventName])) {
+						$out .= ($code ? "\n" : "") . "CKEDITOR.on('". $eventName ."', $code);";
+						$returnedEvents[$eventName][] = $code;
+					}
+				}
+			}
+		}
+
+		return $out;
+	}
+
+	/**
+	 * Initializes CKEditor (executed only once).
+	 * \private
+	 */
+	function init()
+	{
+		static $initComplete;
+		$out = "";
+
+		if (!empty($initComplete)) {
+			return "";
+		}
+
+		if ($this->initialized) {
+			$initComplete = true;
+			return "";
+		}
+
+		$args = "";
+		$ckeditorPath = $this->ckeditorPath();
+
+		if (!empty($this->timestamp) && $this->timestamp != "%TIMESTAMP%") {
+			$args = '?t=' . $this->timestamp;
+		}
+
+		// Skip relative paths...
+		if (strpos($ckeditorPath, '..') !== 0) {
+			$out .= $this->script("window.CKEDITOR_BASEPATH='". $ckeditorPath ."';");
+		}
+
+		$out .= "<script type=\"text/javascript\" src=\"" . $ckeditorPath . 'ckeditor.js' . $args . "\"></script>\n";
+
+		$extraCode = "";
+		// CKReleaser %REMOVE_START% 
+		if ($this->version == '%VERSION%') { 
+			$extraCode .= ($extraCode ? "\n" : "") . "if (typeof(CKEDITOR) == 'undefined') { alert('The CKEDITOR object was not found. Please make sure that the ckeditor.js file is available in your installation.'); }";
+		}
+		// %REMOVE_END% 
+		if (!empty($this->timestamp) && $this->timestamp != $this->_timestamp) {
+			$extraCode .= ($extraCode ? "\n" : "") . "CKEDITOR.timestamp = '". $this->timestamp ."';";
+		}
+		if ($extraCode) {
+			$out .= $this->script($extraCode);
+		}
+
+		$initComplete = $this->initialized = true;
+
+		return $out;
+	}
+
+	/**
+	 * Return path to ckeditor.js.
+	 * \private
+	 */
+	function ckeditorPath()
+	{
+		if (!empty($this->basePath)) {
+			return $this->basePath;
+		}
+
+		/**
+		 * The absolute pathname of the currently executing script.
+		 * Note: If a script is executed with the CLI, as a relative path, such as file.php or ../file.php,
+		 * $_SERVER['SCRIPT_FILENAME'] will contain the relative path specified by the user.
+		 */
+		if (isset($_SERVER['SCRIPT_FILENAME'])) {
+			$realPath = dirname($_SERVER['SCRIPT_FILENAME']);
+		}
+		else {
+			/**
+			 * realpath — Returns canonicalized absolute pathname
+			 */
+			$realPath = realpath( './' ) ;
+		}
+
+		/**
+		 * The filename of the currently executing script, relative to the document root.
+		 * For instance, $_SERVER['PHP_SELF'] in a script at the address http://example.com/test.php/foo.bar
+		 * would be /test.php/foo.bar.
+		 */
+		$selfPath = dirname($_SERVER['PHP_SELF']);
+		$file = str_replace("\\", "/", __FILE__);
+
+		if (!$selfPath || !$realPath || !$file) {
+			return "/ckeditor/";
+		}
+
+		$documentRoot = substr($realPath, 0, strlen($realPath) - strlen($selfPath));
+		$fileUrl = substr($file, strlen($documentRoot));
+		$ckeditorUrl = str_replace("ckeditor_php5.php", "", $fileUrl);
+
+		return $ckeditorUrl;
+	}
+
+	/**
+	 * This little function provides a basic JSON support.
+	 * http://php.net/manual/en/function.json-encode.php
+	 * \private
+	 *
+	 * @param mixed $val
+	 * @return string
+	 */
+	function jsEncode($val)
+	{
+		if (is_null($val)) {
+			return 'null';
+		}
+		if ($val === false) {
+			return 'false';
+		}
+		if ($val === true) {
+			return 'true';
+		}
+		if (is_scalar($val))
+		{
+			if (is_float($val))
+			{
+				// Always use "." for floats.
+				$val = str_replace(",", ".", strval($val));
+			}
+
+			// Use @@ to not use quotes when outputting string value
+			if (strpos($val, '@@') === 0) {
+				return substr($val, 2);
+			}
+			else {
+				// All scalars are converted to strings to avoid indeterminism.
+				// PHP's "1" and 1 are equal for all PHP operators, but
+				// JS's "1" and 1 are not. So if we pass "1" or 1 from the PHP backend,
+				// we should get the same result in the JS frontend (string).
+				// Character replacements for JSON.
+				static $jsonReplaces = array(array("\\", "/", "\n", "\t", "\r", "\b", "\f", '"'),
+				array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"'));
+
+				$val = str_replace($jsonReplaces[0], $jsonReplaces[1], $val);
+
+				return '"' . $val . '"';
+			}
+		}
+		$isList = true;
+		for ($i = 0, reset($val); $i < count($val); $i++, next($val))
+		{
+			if (key($val) !== $i)
+			{
+				$isList = false;
+				break;
+			}
+		}
+		$result = array();
+		if ($isList)
+		{
+			foreach ($val as $v) $result[] = $this->jsEncode($v);
+			return '[ ' . join(', ', $result) . ' ]';
+		}
+		else
+		{
+			foreach ($val as $k => $v) $result[] = $this->jsEncode($k).': '.$this->jsEncode($v);
+			return '{ ' . join(', ', $result) . ' }';
+		}
+	}
+}
